# synfig::Layer_PasteCanvas Class Reference

`#include <layer_pastecanvas.h>`

Inheritance diagram for synfig::Layer_PasteCanvas:

List of all members.

## Public Member Functions

sigc::signal< void > & | signal_subcanvas_changed ()
void | update_renddesc ()
virtual void | on_canvas_set ()
void | set_muck_with_time (bool x=false)
etl::handle< synfig::Canvas > | get_sub_canvas () const
void | set_sub_canvas (etl::handle< synfig::Canvas > x)
Real | get_zoom () const
Time | get_time_offset () const
Point | get_origin () const
| Layer_PasteCanvas ()
virtual | ~Layer_PasteCanvas ()
virtual String | get_local_name () const
| Returns a string containing the localized name of the Layer.
virtual bool | set_param (const String &param, const synfig::ValueBase &value)
| Sets the parameter described by param to value.
virtual ValueBase | get_param (const String &param) const
| Get the value of the specified parameter.
virtual Color | get_color (Context context, const Point &pos) const
| Gets the color of the Canvas at pos.
virtual void | set_time (Context context, Time time) const
| Sets the time for the selected Layer and those under it.
virtual bool | accelerated_render (Context context, Surface *surface, int quality, const RendDesc &renddesc, ProgressCallback *cb) const
| Renders the Canvas to the given Surface in an accelerated manner.
virtual Vocab | get_param_vocab () const
| Gets the parameter vocabulary.
virtual synfig::Rect | get_bounding_rect () const
virtual synfig::Layer::Handle | hit_check (synfig::Context context, const synfig::Point &point) const
| Checks to see if a part of the layer is directly under point.

## Protected Member Functions

virtual void | get_times_vfunc (Node::time_set &set) const
| Called to figure out the animation time information.

## Constructor & Destructor Documentation

Layer_PasteCanvas::Layer_PasteCanvas | ( |  | ) |

References synfig::Time::begin().

Layer_PasteCanvas::~Layer_PasteCanvas | ( |  | ) | `[virtual]`

References set_sub_canvas().

## Member Function Documentation

sigc::signal<void>& synfig::Layer_PasteCanvas::signal_subcanvas_changed | ( |  | ) | `[inline]`

Referenced by set_sub_canvas().

void Layer_PasteCanvas::update_renddesc | ( |  | ) |

References synfig::Layer::get_canvas().

void Layer_PasteCanvas::on_canvas_set | ( |  | ) | `[virtual]`

Reimplemented from synfig::Layer.

References synfig::Layer::get_canvas().

Referenced by set_sub_canvas().

void synfig::Layer_PasteCanvas::set_muck_with_time | ( | bool | x = `false` | ) | `[inline]`

etl::handle<synfig::Canvas> synfig::Layer_PasteCanvas::get_sub_canvas | ( |  | ) | const`[inline]`

Referenced by synfig::optimize_layers().

void Layer_PasteCanvas::set_sub_canvas | ( | etl::handle< synfig::Canvas > | x | ) |

References synfig::Node::add_child(), synfig::Layer::get_canvas(), on_canvas_set(), synfig::Node::remove_child(), and signal_subcanvas_changed().

Referenced by synfig::optimize_layers(), set_param(), synfig::Canvas::~Canvas(), and ~Layer_PasteCanvas().

Real synfig::Layer_PasteCanvas::get_zoom | ( |  | ) | const`[inline]`

Referenced by synfig::optimize_layers().

Time synfig::Layer_PasteCanvas::get_time_offset | ( |  | ) | const`[inline]`

Referenced by synfig::optimize_layers().

Point synfig::Layer_PasteCanvas::get_origin | ( |  | ) | const`[inline]`

Referenced by synfig::optimize_layers().

String Layer_PasteCanvas::get_local_name | ( |  | ) | const`[virtual]`

Returns a string containing the localized name of the Layer.

Reimplemented from synfig::Layer.

References _, and synfig::Layer::get_canvas().

bool Layer_PasteCanvas::set_param | ( | const String & | param,
|  | const synfig::ValueBase & | value |
| ) |  |  | `[virtual]`

Sets the parameter described by param to value.

Parameters:

  | param | The name of the parameter to set
  | value | What the parameter is to be set to.

Returns:
  `true` on success, `false` upon rejection or failure. If it returns `false`, then the Layer is assumed to remain unchanged.

See also:
  get_param()

Todo:
  param should be of the type `const String &param`

Reimplemented from synfig::Layer_Composite.

References synfig::Node::changed(), synfig::ValueBase::get(), IMPORT, synfig::ValueBase::put(), synfig::ValueBase::same_type_as(), synfig::Layer_Composite::set_param(), and set_sub_canvas().

ValueBase Layer_PasteCanvas::get_param | ( | const String & | param | ) | const`[virtual]`

Get the value of the specified parameter.

Returns:
  The requested parameter value, or (upon failure) a NIL ValueBase.

See also:
  set_param()

Todo:
  param should be of the type `const String &`

Reimplemented from synfig::Layer_Composite.

References EXPORT, EXPORT_NAME, EXPORT_VERSION, and synfig::Layer_Composite::get_param().

Color Layer_PasteCanvas::get_color | ( | Context | context,
|  | const Point & | pos |
| ) |  |  | const`[virtual]`

Gets the color of the Canvas at pos.

Parameters:

  | context | Context iterator referring to next Layer.
  | pos | Point which indicates where the Color should come from

See also:
  Handle::get_color()

Reimplemented from synfig::Layer.

References synfig::Color::alpha(), synfig::Color::blend(), synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), synfig::Context::get_color(), and MAX_DEPTH.

void Layer_PasteCanvas::set_time | ( | Context | context,
|  | Time | time |
| ) |  |  | const`[virtual]`

Sets the time for the selected Layer and those under it.

Parameters:

  | context | Context iterator referring to next Layer.
  | time | writeme

See also:
  Handle::set_time()

Reimplemented from synfig::Layer.

References MAX_DEPTH, synfig::Context::set_time(), and zero().

bool Layer_PasteCanvas::accelerated_render | ( | Context | context,
|  | Surface * | surface,
|  | int | quality,
|  | const RendDesc & | renddesc,
|  | ProgressCallback * | cb |
| ) |  |  | const`[virtual]`

Renders the Canvas to the given Surface in an accelerated manner.

Parameters:

  | context | Context iterator referring to next Layer.
  | surface | Pointer to Surface to render to.
  | quality | The requested quality-level to render at.
  | renddesc | The associated RendDesc.
  | cb | Pointer to callback object. May be NULL if there is no callback.

Returns:
  `true` on success, `false` on failure

See also:
  Handle::accelerated_render()

Reimplemented from synfig::Layer_Composite.

References synfig::Context::accelerated_render(), synfig::ProgressCallback::amount_complete(), synfig::Time::begin(), synfig::Color::BLEND_ALPHA_BRIGHTEN, synfig::Color::BLEND_COMPOSITE, synfig::Color::BLEND_STRAIGHT, synfig::Surface::blit_to(), synfig::Surface::clear(), synfig::RendDesc::clear_flags(), synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), synfig::RendDesc::get_br(), synfig::Context::get_full_bounding_rect(), synfig::RendDesc::get_h(), synfig::RendDesc::get_ph(), synfig::RendDesc::get_pw(), synfig::RendDesc::get_rect(), synfig::RendDesc::get_tl(), synfig::RendDesc::get_w(), intersect(), synfig::Color::is_onto(), synfig::Layer_Composite::is_solid_color(), synfig::Color::is_straight(), MAX_DEPTH, synfig::RendDesc::PX_ASPECT, synfig::RendDesc::set_br(), synfig::RendDesc::set_flags(), synfig::RendDesc::set_subwindow(), synfig::RendDesc::set_tl(), and synfig::warning().

Layer::Vocab Layer_PasteCanvas::get_param_vocab | ( | void |  | ) | const`[virtual]`

Gets the parameter vocabulary.

Reimplemented from synfig::Layer_Composite.

References _, synfig::Layer_Composite::get_param_vocab(), and synfig::Layer::set_description().

Rect Layer_PasteCanvas::get_bounding_rect | ( |  | ) | const`[virtual]`

Reimplemented from synfig::Layer.

synfig::Layer::Handle Layer_PasteCanvas::hit_check | ( | synfig::Context | context,
|  | const synfig::Point & | point |
| ) |  |  | const`[virtual]`

Checks to see if a part of the layer is directly under point.

Parameters:

  | context | Context iterator referring to next Layer.
  | point | The point to check

Returns:
  The handle of the layer under point. If there is not a layer under point, then returns an empty handle.

Reimplemented from synfig::Layer.

References synfig::Layer_Composite::get_amount(), synfig::Context::hit_check(), and MAX_DEPTH.

void Layer_PasteCanvas::get_times_vfunc | ( | Node::time_set & | set | ) | const`[protected, virtual]`

Called to figure out the animation time information.

Reimplemented from synfig::Layer.

References ADJUST_WAYPOINTS_FOR_TIME_OFFSET, and synfig::Layer::get_times_vfunc().

The documentation for this class was generated from the following files:

- layer_pastecanvas.h
- layer_pastecanvas.cpp